
Ruby - Bug #20165

Ractors moving a Struct breaks beyond the first 3 fields

01/08/2024 09:02 PM - codekitchen (Brian Palmer)

Status: Closed   

Priority: Normal   

Assignee: ractor   

Target version:    

ruby -v: ruby 3.3.0 (2023-12-25 revision

5124f9ac75) [arm64-darwin23]

Backport: 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2:

UNKNOWN, 3.3: UNKNOWN

Description

Experimenting with Ractors on ruby 3.3.0, and I'm seeing a bug where if you move a struct between ractors, all but the first 3 fields

are set to nil.

Foo = Struct.new(:a,:b,:c,:d,:e,:f)

r = Ractor.new {

  foo = Foo[0,0,0,0,0,0]

  p foo

  Ractor.yield(foo, move: true)

}

p r.take

 
❯ ruby -v

ruby 3.3.0 (2023-12-25 revision 5124f9ac75) [arm64-darwin23]

❯ ruby rbug.rb       

rbug.rb:3: warning: Ractor is experimental, and the behavior may change in future versions of Ruby

! Also there are many implementation issues.

#<struct Foo a=0, b=0, c=0, d=0, e=0, f=0>

#<struct Foo a=0, b=0, c=0, d=nil, e=nil, f=nil>

 This seems specific to moving, if I set move: false the struct makes it across OK.

Related issues:

Related to Ruby - Bug #20271: Issue with moving embedded string across ractors Closed

Related to Ruby - Bug #20267: Hashes that use ar_table aren't moved properly ... Closed

Related to Ruby - Bug #20255: Embedded arrays aren't moved correctly across r... Closed

History

#1 - 01/10/2024 07:26 PM - luke-gru (Luke Gruber)

I sent a fix for this here https://github.com/ruby/ruby/pull/9910/

Also, currently Ractors are not working well on Ruby 3.3, if you're working with them I suggest staying on 3.2 for now.

#2 - 05/08/2025 10:38 PM - jhawthorn (John Hawthorn)

- Assignee set to ractor

#3 - 05/09/2025 08:19 AM - byroot (Jean Boussier)

- Status changed from Open to Closed

Duplicate of: [Bug #20271] [Bug #20267] [Bug #20255]

This was fixed in 0350290262ea0fbc4e1807901797ee8a6970c2b9 and a few followups.

#4 - 05/09/2025 08:19 AM - byroot (Jean Boussier)

- Related to Bug #20271: Issue with moving embedded string across ractors added

#5 - 05/09/2025 08:19 AM - byroot (Jean Boussier)

- Related to Bug #20267: Hashes that use ar_table aren't moved properly across ractors added
#6 - 05/09/2025 08:19 AM - byroot (Jean Boussier)

- Related to Bug #20255: Embedded arrays aren't moved correctly across ractors added
